OGRE: Ogre::v1::Rectangle2D Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Ogre::v1::Rectangle2D Class Reference
Core | Component » Scene

Allows the rendering of a simple 2D rectangle This class renders a simple 2D rectangle; this rectangle has no depth and therefore is best used with 'depth_write off' materials. More...

`#include <OgreRectangle2D.h>`

Inheritance diagram for Ogre::v1::Rectangle2D:
[legend]

## Public Types
typedef map< size_t, Vector4 >::type | CustomParameterMap
typedef FastArray< MovableObject * > | MovableObjectArray
| @See SceneManager::cullFrustum More...

## Public Member Functions
| Rectangle2D (bool bQuad, IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager)
| ~Rectangle2D ()
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object. More...
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only) More...
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state. More...
const Matrix4 & | _getParentNodeFullTransform (void) const
| Returns the full transformation of the parent sceneNode or the attachingPoint node. More...
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node. More...
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only) More...
virtual void | _notifyParentNodeMemoryChanged (void)
| @See Node::_callMemoryChangeListeners More...
virtual void | _notifyStaticDirty (void) const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly. More...
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost. More...
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored. More...
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly. More...
virtual void | _setNullDatablock (void)
| Sets the datablock to a null pointer. More...
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. More...
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue. More...
void | addPoseWeight (size_t index, float w)
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value. More...
void | detachFromParent (void)
| Detaches an object from a parent SceneNode if attached. More...
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object. More...
RealAsUint | getCachedDistanceToCamera (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
Real | getCachedDistanceToCameraAsReal (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object. More...
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow. More...
uint8 | getCurrentMaterialLod (void) const
unsigned char | getCurrentMeshLod (void) const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index. More...
const CustomParameterMap & | getCustomParameters (void) const
HlmsDatablock * | getDatablock (void) const
uint32 | getHlmsCasterHash (void) const
uint32 | getHlmsHash (void) const
IdType | getId () const
| Get the unique id of this object. More...
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object. More...
virtual const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable. More...
Listener * | getListener (void) const
| Gets the current listener for this object. More...
Aabb | getLocalAabb (void) const
| Retrieves the local axis-aligned bounding box for this object. More...
float | getLocalRadius (void) const
| See getLocalAabb and getWorldRadius. More...
MaterialPtr | getMaterial (void) const
| Retrieves the material this renderable object uses. More...
virtual const String & | getMovableType (void) const
| Returns the type name of this object. More...
const String & | getName (void) const
| Returns the name of this object. More...
unsigned short | getNumPoses (void) const
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires. More...
Node * | getParentNode (void) const
| Returns the node to which this object is attached. More...
SceneNode * | getParentSceneNode (void) const
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object. More...
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered. More...
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
virtual void | getRenderOperation (RenderOperation &op, bool casterPass)
| Gets the render operation required to send this object to the frame buffer. More...
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details. More...
uint8 | getRenderQueueSubGroup (void) const
Real | getShadowRenderingDistance (void) const
| Gets the distance at which batches are no longer casting shadows. More...
SkeletonInstance * | getSkeletonInstance (void) const
Real | getSquaredViewDepth (const Camera *cam) const
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection. More...
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view. More...
virtual bool | getUseIdentityViewProjMatrixIsDynamic (void) const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization) More...
virtual bool | getUseIdentityWorldMatrix (void) const
| Returns whether the world matrix is an identity matrix. More...
virtual OGRE_DEPRECATED const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object. More...
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component. More...
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space. More...
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space. More...
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
virtual void | getWorldTransforms (Matrix4 *xform) const
| Gets the world transform matrix / matrices for this renderable object. More...
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index. More...
bool | hasSkeletonAnimation (void) const
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
| @See InstancingTheadedCullingMethod, More...
bool | isAttached (void) const
| Returns true if this object is attached to a Node. More...
bool | isStatic () const
| Checks whether this MovableObject is static. @See setStatic. More...
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered. More...
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered. More...
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object. More...
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index. More...
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows. More...
void | setCorners (Real left, Real top, Real width, Real height)
| Sets the corners of the rectangle, in relative coordinates. More...
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. More...
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable. More...
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e. More...
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials. More...
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object. More...
void | setListener (Listener *listener)
| Sets a listener for this object. More...
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object. More...
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials. More...
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS @See setHlms. More...
void | setName (const String &name)
| Sets a custom name for this node. More...
void | setNormals (const Ogre::Vector3 &topLeft, const Ogre::Vector3 &bottomLeft, const Ogre::Vector3 &topRight, const Ogre::Vector3 &bottomRight)
| Sets the normals of the rectangle. More...
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
void | setPoseWeight (size_t index, float w)
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object. More...
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered. More...
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through. More...
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group. More...
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows. More...
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic. More...
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection. More...
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view. More...
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object. More...
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component. More...

## Static Public Member Functions
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
| @See SceneManager::buildLightList More...
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| @See SceneManager::cullLights & More...
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances. More...
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances. More...
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances. More...
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances. More...
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances. More...
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances. More...
static void | updateAllBounds (const size_t numNodes, ObjectData t)
| @See SceneManager::updateAllBounds More...

## Public Attributes
uint8 | mCustomParameter
| Only valid when using low level materials. More...
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock. More...
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
RenderableArray | mRenderables

## Static Public Attributes
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Allows the rendering of a simple 2D rectangle This class renders a simple 2D rectangle; this rectangle has no depth and therefore is best used with 'depth_write off' materials.

  Beginning Ogre 2.0, it supports building a full screen triangle instead of rectangle. Position & UVs are in the first source. Normals are in the second one

## Member Typedef Documentation

## ◆ CustomParameterMap

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap
| inherited

## ◆ MovableObjectArray

typedef FastArray<MovableObject*> Ogre::MovableObject::MovableObjectArray
| inherited

@See SceneManager::cullFrustum

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing) We perform frustum culling AND test visibility mask at the same time

Parameters

  frustum | Frustum to clip against
  sceneVisibilityFlags | Combined scene's visibility flags (i.e. viewport | scene). Set LAYER_SHADOW_CASTER bit if you want to exclude non-shadow casters.
  outCulledObjects | Out. List of objects that are (fully or partially) inside the frustum and should be rendered
  lodCamera | Camera in which lod levels calculations are based (i.e. during shadow pass renders) Note however, we only use this camera to calulate if should be visible according to mUpperDistance

## Constructor & Destructor Documentation

## ◆ Rectangle2D()

Ogre::v1::Rectangle2D::Rectangle2D | ( | bool | bQuad,
|  | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager
| ) |  |

## ◆ ~Rectangle2D()

Ogre::v1::Rectangle2D::~Rectangle2D | ( |  | ) |

## Member Function Documentation

## ◆ _getLightList()

LightList* Ogre::MovableObject::_getLightList | ( |  | ) |
| inlineinherited

Returns a pointer to the current list of lights for this object.

Remarks
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ _getManager()

SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inlineinherited

Get the manager of this object, if any (internal use only)

## ◆ _getObjectData()

ObjectData& Ogre::MovableObject::_getObjectData | ( |  | ) |
| inlineinherited

Returns a direct access to the ObjectData state.

## ◆ _getParentNodeFullTransform()

const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| inherited

Returns the full transformation of the parent sceneNode or the attachingPoint node.

## ◆ _notifyAttached()

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent | ) |
| virtualinherited

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::ParticleSystem, and Ogre::v1::Entity.

## ◆ _notifyManager()

void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlineinherited

Notify the object of it's manager (internal use only)

## ◆ _notifyParentNodeMemoryChanged()

virtual void Ogre::MovableObject::_notifyParentNodeMemoryChanged | ( | void |  | ) |
| inlinevirtualinherited

@See Node::_callMemoryChangeListeners

Reimplemented in Ogre::Item.

## ◆ _notifyStaticDirty()

virtual void Ogre::MovableObject::_notifyStaticDirty | ( | void |  | ) | const
| inlinevirtualinherited

Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.

See also
  SceneManager::notifyStaticDirty

## ◆ _releaseManualHardwareResources()

virtual void Ogre::MovableObject::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::v1::ManualObject, and Ogre::v1::BillboardSet.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources should be restored.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

## ◆ _setHlmsHashes()

virtual void Ogre::Renderable::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash
| ) |  |
| virtualinherited

Manually sets the hlms hashes. Don't call this directly.

Reimplemented in Ogre::SubItem.

## ◆ _setNullDatablock()

virtual void Ogre::Renderable::_setNullDatablock | ( | void |  | ) |
| virtualinherited

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters_AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) |  | const
| virtualinherited

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::v1::SubEntity.

## ◆ _updateRenderQueue()

virtual void Ogre::MovableObject::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| inlinevirtualinherited

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Reimplemented in Ogre::v1::StaticGeometry::Region, Ogre::ParticleSystem, Ogre::v1::ManualObject, Ogre::Light, Ogre::v1::Entity, Ogre::v1::BillboardSet, Ogre::MovablePlane, and Ogre::v1::BillboardChain.

## ◆ addPoseWeight()

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ buildLightList()

static void Ogre::MovableObject::buildLightList | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const LightListInfo & | globalLightList
| ) |  |
| staticinherited

@See SceneManager::buildLightList

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

Parameters

  globalLightList | List of lights already culled against all possible frustums and reorganized contiguously for SoA

## ◆ calculateCastersBox()

static void Ogre::MovableObject::calculateCastersBox | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneVisibilityFlags,
|  | AxisAlignedBox * | outBox
| ) |  |
| staticinherited

## ◆ createAnimableValue()

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) |
| inlinevirtualinherited

Create a reference-counted AnimableValuePtr for the named value.

Remarks
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ cullFrustum()

static void Ogre::MovableObject::cullFrustum | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | frustum,
|  | uint32 | sceneVisibilityFlags,
|  | MovableObjectArray & | outCulledObjects,
|  | const Camera * | lodCamera
| ) |  |
| staticinherited

## ◆ cullLights()

static void Ogre::MovableObject::cullLights | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneLightMask,
|  | LightListInfo & | outGlobalLightList,
|  | const FrustumVec & | frustums,
|  | const FrustumVec & | cubemapFrustums
| ) |  |
| staticinherited

@See SceneManager::cullLights &

See also
  MovableObject::cullFrustum Produces the global list of visible lights that is needed in buildLightList

Remarks
  We don't pass ObjectData by reference on purpose (avoid implicit aliasing) It's declared here because all affected elements are from MovableObject IMPORTANT: It is assumed that all objects in ObjectData are Lights.

Parameters

  outGlobalLightList | Output, a list of lights, contiguously placed
  frustums | An array of all frustums we need to check against
  cubemapFrustums | An array of all frustums that are used at least once as cubemaps (@See SceneManager::createCamera)

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |
| inherited

Detaches an object from a parent SceneNode if attached.

## ◆ getAnimableValueNames()

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const
| inlineinherited

Gets a list of animable value names for this object.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCachedDistanceToCamera()

RealAsUint Ogre::MovableObject::getCachedDistanceToCamera | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCachedDistanceToCameraAsReal()

Real Ogre::MovableObject::getCachedDistanceToCameraAsReal | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineinherited

Returns whether shadow casting is enabled for this object.

## ◆ getCastsShadows()

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const
| inlinevirtualinherited

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::ManualObject::ManualObjectSection, Ogre::WireAabb, Ogre::SubItem, Ogre::v1::SubEntity, Ogre::v1::StaticGeometry::GeometryBucket, Ogre::Rectangle2D, Ogre::VoxelVisualizer, and Ogre::IfdProbeVisualizer.

## ◆ getCurrentMaterialLod()

uint8 Ogre::Renderable::getCurrentMaterialLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCurrentMeshLod()

unsigned char Ogre::MovableObject::getCurrentMeshLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCustomParameter()

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCustomParameters()

const CustomParameterMap& Ogre::Renderable::getCustomParameters | ( | void |  | ) | const
| inlineinherited

## ◆ getDatablock()

HlmsDatablock* Ogre::Renderable::getDatablock | ( | void |  | ) | const
| inlineinherited

## ◆ getDefaultLightMask()

static uint32 Ogre::MovableObject::getDefaultLightMask | ( |  | ) |
| inlinestaticinherited

Get the default light mask for all future MovableObject instances.

## ◆ getDefaultQueryFlags()

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestaticinherited

Get the default query flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestaticinherited

Get the default visibility flags for all future MovableObject instances.

## ◆ getHlmsCasterHash()

uint32 Ogre::Renderable::getHlmsCasterHash | ( | void |  | ) | const
| inlineinherited

## ◆ getHlmsHash()

uint32 Ogre::Renderable::getHlmsHash | ( | void |  | ) | const
| inlineinherited

## ◆ getId()

IdType Ogre::IdObject::getId | ( |  | ) | const
| inlineinherited

Get the unique id of this object.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inlineinherited

Get a bitwise mask which will filter the lights affecting this object.

Remarks
  By default, this mask is fully set meaning all lights will affect this object

## ◆ getLights()

virtual const LightList& Ogre::v1::Rectangle2D::getLights | ( | void |  | ) | const
| virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getListener()

Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const
| inlineinherited

Gets the current listener for this object.

## ◆ getLocalAabb()

Aabb Ogre::MovableObject::getLocalAabb | ( | void |  | ) | const
| inherited

Retrieves the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ getLocalRadius()

float Ogre::MovableObject::getLocalRadius | ( | void |  | ) | const
| inherited

See getLocalAabb and getWorldRadius.

## ◆ getMaterial()

MaterialPtr Ogre::Renderable::getMaterial | ( | void |  | ) | const
| inherited

Retrieves the material this renderable object uses.

It may be null if it's using the HLMS. @See getDatablock

## ◆ getMovableType()

virtual const String& Ogre::v1::Rectangle2D::getMovableType | ( | void |  | ) | const
| virtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getName()

const String& Ogre::MovableObject::getName | ( | void |  | ) | const
| inlineinherited

Returns the name of this object.

## ◆ getNumPoses()

unsigned short Ogre::Renderable::getNumPoses | ( | void |  | ) | const
| inherited

## ◆ getNumWorldTransforms()

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of world transform matrices this renderable requires.

Remarks
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BorderRenderable.

## ◆ getParentNode()

Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inlineinherited

Returns the node to which this object is attached.

## ◆ getParentSceneNode()

SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const
| inlineinherited

## ◆ getPolygonModeOverrideable()

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const
| inlinevirtualinherited

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::v1::BorderRenderable.

Referenced by Ogre::v1::BorderRenderable::getPolygonModeOverrideable().

## ◆ getPoseHalfPrecision()

bool Ogre::Renderable::getPoseHalfPrecision | ( |  | ) | const
| inherited

## ◆ getPoseNormals()

bool Ogre::Renderable::getPoseNormals | ( |  | ) | const
| inherited

## ◆ getPoseTexBuffer()

TexBufferPacked* Ogre::Renderable::getPoseTexBuffer | ( |  | ) | const
| inherited

## ◆ getPoseWeight()

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const
| inherited

## ◆ getPoseWeights()

float* Ogre::Renderable::getPoseWeights | ( |  | ) | const
| inherited

## ◆ getQueryFlags()

uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlineinherited

Returns the query flags relevant for this object.

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer rendered.

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inlineinherited

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ getRenderOperation()

virtual void Ogre::v1::Rectangle2D::getRenderOperation | ( | RenderOperation & | op,
|  | bool | casterPass
| ) |  |
| virtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inlineinherited

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## ◆ getRenderQueueSubGroup()

uint8 Ogre::Renderable::getRenderQueueSubGroup | ( | void |  | ) | const
| inlineinherited

## ◆ getShadowRenderingDistance()

Real Ogre::MovableObject::getShadowRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer casting shadows.

## ◆ getSkeletonInstance()

SkeletonInstance* Ogre::MovableObject::getSkeletonInstance | ( | void |  | ) | const
| inlineinherited

## ◆ getSquaredViewDepth()

Real Ogre::v1::Rectangle2D::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| inline

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getUseIdentityViewProjMatrixIsDynamic()

virtual bool Ogre::Renderable::getUseIdentityViewProjMatrixIsDynamic | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)

Remarks
  Hlms implementations may ignore this setting (e.g. assume always true or always false) or even not support identity matrix overrides at all. For example currently Unlit supports them all, but will assume this returns always true if getUseIdentityWorldMatrix returns false.

## ◆ getUseIdentityWorldMatrix()

virtual bool Ogre::Renderable::getUseIdentityWorldMatrix | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the world matrix is an identity matrix.

Remarks
  It is up to the Hlms implementation whether to honour this request. Take in mind changes of this value at runtime may not be seen until the datablock is flushed. It is implemented as a virtual call because this functionality isn't required very often (hence we save per-Renderable space for those that don't use it) and this function will be called at creation time to use a different shader; not during rendering time per Renderable.

Reimplemented in Ogre::v1::BillboardSet.

## ◆ getUserAny()

virtual OGRE_DEPRECATED const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

## ◆ getUserObjectBindings() [1/4]

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/4]

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [3/4]

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [4/4]

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVaos()

const VertexArrayObjectArray& Ogre::Renderable::getVaos | ( | VertexPass | vertexPass | ) | const
| inlineinherited

## ◆ getVisibilityFlags()

uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlineinherited

Returns the visibility flags relevant for this object.

Reserved visibility flags are not returned.

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inlineinherited

Gets this object whether to be visible or not, if it has a renderable component.

Remarks
  Returns the value set by MovableObject::setVisible only.

## ◆ getWorldAabb()

Aabb Ogre::MovableObject::getWorldAabb | ( |  | ) | const
| inherited

Gets the axis aligned box in world space.

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldAabbUpdated if you need the update process to be guaranteed

## ◆ getWorldAabbUpdated()

Aabb Ogre::MovableObject::getWorldAabbUpdated | ( |  | ) |
| inherited

Gets the axis aligned box in world space.

Remarks
  Unlike getWorldAabb, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldRadius()

float Ogre::MovableObject::getWorldRadius | ( |  | ) | const
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldRadiusUpdated if you need the update process to be guaranteed

## ◆ getWorldRadiusUpdated()

float Ogre::MovableObject::getWorldRadiusUpdated | ( |  | ) |
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Unlike getWorldRadius, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldTransforms()

virtual void Ogre::v1::Rectangle2D::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| virtual

Gets the world transform matrix / matrices for this renderable object.

Remarks
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate transform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also
  Matrix4::isAffine.

Implements Ogre::Renderable.

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ hasSkeletonAnimation()

bool Ogre::Renderable::hasSkeletonAnimation | ( | void |  | ) | const
| inlineinherited

## ◆ instanceBatchCullFrustumThreaded()

virtual void Ogre::MovableObject::instanceBatchCullFrustumThreaded | ( | const Frustum * | frustum,
|  | const Camera * | lodCamera,
|  | uint32 | combinedVisibilityFlags
| ) |  |
| inlinevirtualinherited

@See InstancingTheadedCullingMethod,

See also
  InstanceBatch::instanceBatchCullFrustumThreaded

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inlineinherited

Returns true if this object is attached to a Node.

## ◆ isStatic()

bool Ogre::MovableObject::isStatic | ( |  | ) | const
| inherited

Checks whether this MovableObject is static. @See setStatic.

## ◆ isVisible()

bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not this object is supposed to be visible or not.

Remarks
  Takes into account visibility flags and the setVisible, but not rendering distance.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator()() [1/2]

bool Ogre::IdObject::operator() | ( | const IdObject & | left,
|  | const IdObject & | right
| ) |  |
| inlineinherited

## ◆ operator()() [2/2]

bool Ogre::IdObject::operator() | ( | const IdObject * | left,
|  | const IdObject * | right
| ) |  |
| inlineinherited

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called immediately after the Renderable has been rendered.

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::v1::BillboardChain.

## ◆ queryLights()

const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const
| inlineinherited

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks
  The lights are filled in

See also
  buildLightList

Returns
  The list of lights use to lighting this object.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |
| inlineinherited

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inlineinherited

Sets whether or not this object will cast shadows.

Remarks
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ setCorners()

void Ogre::v1::Rectangle2D::setCorners | ( | Real | left,
|  | Real | top,
|  | Real | width,
|  | Real | height
| ) |  |

Sets the corners of the rectangle, in relative coordinates.

Parameters

  left | Left position in screen normalized coordinates, 0 = left edge, 1 = right edge
  top | Top position in screen normalized coordinates, 0 = top edge, 1 = bottom edge
  width | Width in screen normalized coordinates
  height | Height in screen normalized coordinates

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) |  |
| inlineinherited

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ setDatablock() [1/2]

virtual void Ogre::Renderable::setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtualinherited

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ setDatablock() [2/2]

void Ogre::Renderable::setDatablock | ( | IdString | datablockName | ) |
| inherited

Assigns a datablock (i.e.

HLMS material) based on its unique name.

Remarks
  An null IdString() is valid, it will use the default material

## ◆ setDatablockOrMaterialName()

void Ogre::Renderable::setDatablockOrMaterialName | ( | String | materialName,
|  | String | groupName
| ) |  |
| inherited

First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.

## ◆ setDefaultLightMask()

static void Ogre::MovableObject::setDefaultLightMask | ( | uint32 | mask | ) |
| inlinestaticinherited

Set the default light mask for all future MovableObject instances.

## ◆ setDefaultQueryFlags()

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default query flags for all future MovableObject instances.

## ◆ setDefaultVisibilityFlags()

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default visibility flags for all future MovableObject instances.

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |
| inlineinherited

Set a bitwise mask which will filter the lights affecting this object.

Remarks
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inlineinherited

Sets a listener for this object.

Remarks
  Note for size and performance reasons only one listener per object is allowed.

## ◆ setLocalAabb()

void Ogre::MovableObject::setLocalAabb | ( | const Aabb | box | ) |
| inherited

Sets the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ setMaterial()

virtual void Ogre::Renderable::setMaterial | ( | const MaterialPtr & | material | ) |
| virtualinherited

Sets the given material. Overrides HLMS materials.

Reimplemented in Ogre::v1::SubEntity, Ogre::v1::BillboardSet, and Ogre::v1::SimpleRenderable.

## ◆ setMaterialName()

void Ogre::Renderable::setMaterialName | ( | const String & | name,
|  | const String & | groupName
| ) |  |
| inherited

Sets the name of the Material to be used. Prefer using HLMS @See setHlms.

## ◆ setName()

void Ogre::MovableObject::setName | ( | const String & | name | ) |
| inlineinherited

Sets a custom name for this node.

Doesn't have to be unique

## ◆ setNormals()

void Ogre::v1::Rectangle2D::setNormals | ( | const Ogre::Vector3 & | topLeft,
|  | const Ogre::Vector3 & | bottomLeft,
|  | const Ogre::Vector3 & | topRight,
|  | const Ogre::Vector3 & | bottomRight
| ) |  |

Sets the normals of the rectangle.

Remarks
  Be careful the normals can be bilinearly interpolated correctly, otherwise the results between Fullscreen Triangles & Fullscreen Quads will be different

## ◆ setPolygonModeOverrideable()

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inlinevirtualinherited

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ setPoseWeight()

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the query flags for this object.

Remarks
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer rendered.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is FLT_MAX, which means objects are always rendered). Values equal or below zero will be ignored, and cause an assertion in debug mode.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inlineinherited

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ setRenderQueueGroup()

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtualinherited

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented in Ogre::ParticleSystem, Ogre::Light, Ogre::InternalCubemapProbe, Ogre::v1::Entity, and Ogre::Decal.

## ◆ setRenderQueueSubGroup()

void Ogre::Renderable::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inlineinherited

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits ) @See RenderQueue

## ◆ setShadowRenderingDistance()

void Ogre::MovableObject::setShadowRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer casting shadows.

Parameters

  dist | Distance beyond which the object will not cast shadows (the default is FLT_MAX, which means objects are always casting shadows). Values equal or below zero will be ignored, and cause an assertion in debug mode.

Note
  ShadowRenderingDistance will be clamped to RenderingDistance value

See also
  setRenderingDistance

## ◆ setStatic()

bool Ogre::MovableObject::setStatic | ( | bool | bStatic | ) |
| inherited

Turns this Node into static or dynamic.

Remarks
  Switching between dynamic and static has some overhead and forces to update all static scene when converted to static. So don't do it frequently. Static objects are not updated every frame, only when requested explicitly. Use this feature if you plan to have this object unaltered for a very long times

  Note all MovableObjects support switching between static & dynamic after they have been created (eg. InstancedEntity)

  Changing this attribute will cause to switch the attribute to our parent node, and as a result, all of its other attached entities. @See Node::setStatic

Returns
  True if setStatic made an actual change. False otherwise. Can fail because the object was already static/dynamic, or because switching is not supported

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inlineinherited

Sets whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inlineinherited

Sets whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ setUserAny()

virtual OGRE_DEPRECATED void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the visibility flags for this object.

Remarks
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags that is applied a binary 'and' with the SceneManager's mask and a compositor node pass. To exclude particular objects from rendering. Changes to reserved visibility flags are ignored (won't take effect).

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inlineinherited

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

## ◆ updateAllBounds()

static void Ogre::MovableObject::updateAllBounds | ( | const size_t | numNodes,
|  | ObjectData | t
| ) |  |
| staticinherited

@See SceneManager::updateAllBounds

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

## Member Data Documentation

## ◆ c_DefaultLodMesh

const FastArray<Real> Ogre::MovableObject::c_DefaultLodMesh
| staticinherited

## ◆ mCustomParameter

uint8 Ogre::Renderable::mCustomParameter
| inherited

Only valid when using low level materials.

## ◆ mGlobalIndex

size_t Ogre::MovableObject::mGlobalIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mHlmsGlobalIndex

uint32 Ogre::Renderable::mHlmsGlobalIndex
| inherited

Index in the vector holding this Rendrable reference in the HLMS datablock.

Used for O(1) removals.

Remarks
  Despite being public, Do NOT modify it manually.

## ◆ mParentIndex

size_t Ogre::MovableObject::mParentIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mRenderables

RenderableArray Ogre::MovableObject::mRenderables
| inherited

The documentation for this class was generated from the following file:

- OgreRectangle2D.h